/**
 *	@file	DiaKbdMouseHook_Impl.h
 *	@brief	L[{[hŃ}EX삷邽߂̃L[̃tbNpDLL
 *	@auther	Masashi KITAMURA
 *	@date	2006
 *	@note
 *		t[\[X
 */
#ifndef DIAKBDMOUSEHOOK_IMPL_H
#define DIAKBDMOUSEHOOK_IMPL_H
#pragma once

#include <cassert>
#include <windows.h>
#include "DiaKbdMouseHook.h"
#include "../cmn/CriticalSection.hpp"

//#define DIAKBDMOUSEHOOK_USE_EX_SHIFT


/// L[͂擾(̂Ƃ)߂̃tbN
class CDiaKbdMouseHook_Impl {
public:
	enum { VK_NUM = 256 };

	/// 
	static void init(HINSTANCE hInst) { s_hInst_ = hInst; }

	/// tbN
	static bool install(int keycode, CDiaKbdMouseHook_ConvKeyTbl const& tbl);

	/// tbN
	static bool uninstall();

	/// }EXL[{^̂擾
	static unsigned mouseButton();

  #ifdef USE_LWINKEY
	/// Wingon/off
	static bool setLWinMode(int sw);
  #endif

	/// ϊe[uwt@Cǂݍ
	static void setConvTable(const CDiaKbdMouseHook_ConvKey tbl[VK_NUM]);

private:
	static LRESULT CALLBACK LowLevelKeyboardProc(int nCode, WPARAM wparam, LPARAM lparam);

	/// [hؑփL[̃R[hݒ
	static void setModeKeyTbl(unsigned vkMode, CDiaKbdMouseHook_ConvKeyTbl const& tbl);

	static bool keyDownUp(bool sw, unsigned vkCode);
	static void sendConvKey(bool sw, unsigned uKey );
	static void sendKey(int mode, unsigned uFlags, unsigned uVk );
	static void setInputParam(INPUT& rImput, unsigned uFlags, unsigned uVk );

	static bool makeMouseButton( bool sw, unsigned uVk );
	static bool setMouseButton(unsigned btn, bool sw);

	static void clearStat();

 #ifdef DIAKBDMOUSEHOOK_USE_EX_SHIFT
	static void clearExShift();
 #endif

private:
	enum { DiaKbdMouseHook_EXTRAINFO = 0xD1AC };

	static CCriticalSection		s_criticalSection_;
	static HINSTANCE   			s_hInst_;			///< WindowCX^X
	static volatile HHOOK		s_hHook_LL_;		///< tbN
	static unsigned				s_uModeKey_;		///< [hؑփL[̃L[R[h
	static unsigned				s_uMouseButton_;	///< }EXp̃{^
	static int					s_iMouseButtonLife_; ///< (Win+Lł)\̔Qyp
	static bool					s_bConvModeStat_;	///< L[ɂ郂[hon/off
	static bool					s_bTwoStStatQ_;		///< 2Xg[NL[[h
	static bool					s_bShiftStat_;		///< SHIFTĂƂ
	static bool					s_bCtrlStat_;		///< CTRLĂƂ
	static bool					s_bDiaMouse_;		///< _CAhJ[\Ń}EX𓮂
  #ifdef DIAKBDMOUSEHOOK_USE_EX_SHIFT
	static bool					s_bExShift_;		///< J[\ړł̎Vtg
  #endif
  #ifdef USE_LWINKEY
	static bool					s_bLWinStat_;		///< WinL[ɂon/off
	static bool					s_bLWinModeSw_;		///< WinL[ɂL[{[h}EXpon/off
  #endif

	static CDiaKbdMouseHook_ConvKeyTbl	s_convKeys_;
};

#endif
